summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-03-18 16:21:26 +0100
committerJim Meyering <jim@meyering.net>2007-03-18 16:21:26 +0100
commit553d347d3e08e00ee4f9df520b37c964c3f26e28 (patch)
tree189a05248c9fe5251a5bb5d32887125f19c70783
parentb1d89070f620c8787a36d93d67b0431ca15fb1dc (diff)
downloadcoreutils-553d347d3e08e00ee4f9df520b37c964c3f26e28.tar.xz
Fix a bug in how pr -m -s works.
* NEWS: Describe how the fix affects pr. * src/pr.c (init_parameters): The --merge (-m) option does not imply --expand-tabs (-e), so don't set "untabify_input". Reported by Wis Macomson. * tests/misc/pr: New file. Test for the above fix. * tests/misc/Makefile.am (TESTS): Add pr. * THANKS: Update.
-rw-r--r--ChangeLog11
-rw-r--r--NEWS4
-rw-r--r--THANKS1
-rw-r--r--src/pr.c3
-rw-r--r--tests/misc/Makefile.am1
-rwxr-xr-xtests/misc/pr61
6 files changed, 79 insertions, 2 deletions
diff --git a/ChangeLog b/ChangeLog
index c061c9291..aad91cfd7 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,14 @@
+2007-03-18 Jim Meyering <jim@meyering.net>
+
+ Fix a bug in how pr -m -s works.
+ * NEWS: Describe how the fix affects pr.
+ * src/pr.c (init_parameters): The --merge (-m) option does
+ not imply --expand-tabs (-e), so don't set "untabify_input".
+ Reported by Wis Macomson.
+ * tests/misc/pr: New file. Test for the above fix.
+ * tests/misc/Makefile.am (TESTS): Add pr.
+ * THANKS: Update.
+
2007-03-17 Jim Meyering <jim@meyering.net>
Detect use of AC_CONFIG_AUX_DIR also when its argument is quoted.
diff --git a/NEWS b/NEWS
index 57c51e128..4efb18f21 100644
--- a/NEWS
+++ b/NEWS
@@ -10,6 +10,10 @@ GNU coreutils NEWS -*- outline -*-
the DF_BLOCK_SIZE, BLOCK_SIZE, and BLOCKSIZE environment variables. It
is still affected by POSIXLY_CORRECT, though.
+ Using pr -m -s (i.e. merging files, with TAB as the output separator)
+ no longer inserts extraneous spaces between output columns.
+
+
* Noteworthy changes in release 6.8 (2007-02-24) [not-unstable]
** Bug fixes
diff --git a/THANKS b/THANKS
index 1d7aae341..ad05b1350 100644
--- a/THANKS
+++ b/THANKS
@@ -519,6 +519,7 @@ William Bader william@nscs.fast.net
William Dowling will@franklin.com
William Lewis wiml@omnigroup.com
wiregauze wiregauze@yahoo.com
+Wis Macomson wis.macomson@intel.com
Wojciech Purczynski cliph@isec.pl
Wolfram Kleff kleff@cs.uni-bonn.de
Won-kyu Park wkpark@chem.skku.ac.kr
diff --git a/src/pr.c b/src/pr.c
index bd694f49f..e0aea224e 100644
--- a/src/pr.c
+++ b/src/pr.c
@@ -1,5 +1,5 @@
/* pr -- convert text files for printing.
- Copyright (C) 88, 91, 1995-2006 Free Software Foundation, Inc.
+ Copyright (C) 88, 91, 1995-2007 Free Software Foundation, Inc.
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
@@ -1265,7 +1265,6 @@ init_parameters (int number_of_files)
col_sep_string = column_separator;
truncate_lines = true;
- untabify_input = true;
tabify_output = true;
}
else
diff --git a/tests/misc/Makefile.am b/tests/misc/Makefile.am
index 1aa3516f8..4d6a754a8 100644
--- a/tests/misc/Makefile.am
+++ b/tests/misc/Makefile.am
@@ -40,6 +40,7 @@ TESTS_ENVIRONMENT = \
# will execute the test script rather than the standard utility.
TESTS = \
+ pr \
df-P \
pwd-unreadable-parent \
cut \
diff --git a/tests/misc/pr b/tests/misc/pr
new file mode 100755
index 000000000..a40ea31c1
--- /dev/null
+++ b/tests/misc/pr
@@ -0,0 +1,61 @@
+#!/bin/sh
+# -*- perl -*-
+# Exercise a bug with pr -m -s
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+. $srcdir/../envvar-check
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+exec $PERL -w -I$srcdir/.. -MCoreutils -- - <<\EOF
+#/
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+$ENV{PROG} = 'pr';
+my $ME = $ENV{PROG};
+
+# Turn off localization of executable's ouput.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my @Tests =
+ (
+ ['merge-w-tabs', '-m -s -t',
+ {IN=>{1=>"a\tb\tc\n"}},
+ {IN=>{2=>"m\tn\to\n"}},
+ {IN=>{3=>"x\ty\tz\n"}},
+ {OUT=>join("\t", qw(a b c m n o x y z)) . "\n"} ],
+ );
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $prog = $ENV{PROG} || die "$0: \$PROG not specified in environment\n";
+my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF